/*
///////////////////////////////////////////////////////////
Name:	Data Corr
Version:	1.0
Data:	November(11), 25, 2000
Purpose:	Finds regressions of data for linear, 
		exponetial, and variation functions
Note:	This program is mostly written is basic.
		I was planning to use full C, but that proved
		to be a little difficult and complicated.  I kept
		it in a C file because it gave me more control.
///////////////////////////////////////////////////////////
*/


#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File

// Main Function
void _main(void)
{	

TRY		//Full Program Error Recovery 
		//Quits to Home Screen - see ONERR and ENDTRY at end of program
	
	//local variables
	int ii=0;

	int run=1;

	FILE* file;




//Main Title


//Displays Status of Program


//Basic Command, see the basic(string) function on the bottom of the program
//Sorry, can't comment within basic lines

//try checks if the file datareg2 is on the calculator, datareg2 is actually the file
//FolderInfo, released by  "Zeljko Juric and Sebastian Reichelt"

TRY
basic("DelVar regcoef:
Define foldlst=datareg2():
Define sizef=Dim(foldlst):
Define templst=newList(1):  
Define ii=1:
Define kk=1:
Define jj=1:
Define datastr=char(68)&char(65)&char(84)&char(65)");
ONERR
basic("Dialog:
Title \"Error\":
Text \"File datareg2 not found!\":
text \"\":
Text \"Make sure to send both files\":
Text \"datacorr and datareg2.\":
EndDlog");
ENDTRY



//Datastr becomes capitol "DATA"



//Searches all folders for type DATA files
basic("For kk,1,sizef,1:
Define curfold=foldlst[kk]:
Define files=datareg2(curfold):
Define size=Dim(files):
For ii,1,size,1:
Define file=files[ii]:
Define type=expr(\"getType(\"&curfold&\"\\\"&file&\")\"): 
If datastr=type Then:
If curfold=\"main\" Then:
Define templst[jj]=files[ii]:
Else:
Define templst[jj]=curfold&\"\\\"&files[ii]:
EndIf:
Define jj=jj+1:
EndIf:
EndFor:
EndFor:
DelVar files,file,type,datastr,size,curfold,foldlst,kk,sizef");



basic("Define xval=\"1\":
Define yval=\"2\":
Define chfile=1:
Define lenx=0:
Define leny=0");



//First Dialog Box to choose file and columns (c1,c2,...)
TRY
basic("Dialog:
Title \"Data  Setup\":
Text \"\":
DropDown \"Data Variable\",templst,chfile:
Text \"\":
Text \"\":
DropDown \"X is in: \",{\"c1\",\"c2\",\"c3\",\"c4\",\"c5\",\"c6\",\"c7\",\"c8\",\"c9\"},xval:
DropDown \"Y is in: \",{\"c2\",\"c1\",\"c3\",\"c4\",\"c5\",\"c6\",\"c7\",\"c8\",\"c9\"},yval:
EndDlog:
If yval=1 Then:
Define yval=2:
ElseIf yval=2 Then:
Define yval=1:
EndIf:
Define xval=string(xval):
Define yval=string(yval):
Define fname=templst[chfile]:
Define dfile=fname:
DelVar templst,chfile,jj,num,fname");
ONERR	//If no file was found!!!
run=0;
basic("Dialog:
Title \"Error\":
Text \"No data file found in any folder\":
Text \"\":
Text \"\":
EndDlog");
ENDTRY


//If the file was found, continue with the program
if(run==1)
{
	
			

TRY	//Error Capture  - See ONERR below



basic("expr(\"Define fd1=\"&dfile&\"[\"&xval&\"]\"):
expr(\"Define fd2=\"&dfile&\"[\"&yval&\"]\"):
Define lenx=dim(fd1):
Define leny=dim(fd2):
If lenxleny:
Then:
Dialog:
Title \"Error\":
Text \"Num of elements in c\"&xval&\"c\"&yval:
Text \"Check the \"&dfile&\" data file\":
Text \"\":
EndDlog:
Stop:
EndIf:
If lenx=1 or leny=1:
Then:
Dialog:
Title \"Error\":
Text \"Only 1 element in c\"&xval&\" or c\"&yval:
Text \"Check the \"&dfile&\" data file\":
Text \"\":
EndDlog:
Stop:
EndIf:
Define fdlst1=fd1:
Define fdlst2=fd2:
Define fdlst3=log(fdlst1):
Define fdlst4=log(fdlst2):
DelVar lenx,leny,xval,yval");



//Find the regressions 
//each regression is in a list, a is [1] , b is [2], and corr is [3]
basic("LinReg fdlst1,fdlst2:
Define lreg=string(corr):
LinReg fdlst1,fdlst4:
Define ereg=string(corr):
LinReg fdlst3,fdlst4:
Define preg=string(corr):
DelVar fd1,fd2");

//to find the best fitting line(corr closest to +-1), first find absolute diffrence 
//from 1
basic("Define dcl=1-abs(expr(lreg)):
Define dce=1-abs(expr(ereg)):
Define dcp=1-abs(expr(preg))
");

//find best fit, then make the string beqstd(best fit equation standard), and assign the list
//bflst the list of appropriate regressions 


//First if statement is to check if linear corr is 1, if it is skip other tests 
//In that case var reg would also be 1 b/c it would be y = 1x^1
basic("If dcl=0 Then:
Define bfit=\"Linear\":
Else:
If dcl<dce Then:
If dcl<dcp Then:
Define bfit=\"Linear\":
Else:
Define bfit=\"Variation(Power)\":
EndIf:
Else:
If dce<dcp Then:
Define bfit=\"Exponential\":
Else:
Define bfit=\"Variation(Power)\":
EndIf:
EndIf:
EndIf:
DelVar dce,dcl,dcp");

//Display correlation dialog
basic("Dialog:
Title \"Correlations\":
Text \"Best Fit: \"&bfit:
Text \"\":
Text \"Linear           r=\"&lreg:
Text \"Exponential  r=\"&ereg:
Text \"Variation      r=\"&preg:
Text \"\":
EndDlog");






ONERR		//If an error occurs, safely quit
for(ii=0;ii<120;ii++)
	DrawStr(0,85,"Error. Quiting...",A_REVERSE);
ENDTRY

}
//Delete variables that ere used in the program
basic("DelVar templst,bfit,dfile,ii,jj,chfile:
DelVar fd1,fd2,fdlst1,fdlst2,fdlst3,fdlst4,preg,ereg,lreg");


GKeyFlush();		//Empty the keyboard queue, so nothing is written in the home sceen after it quiits

ONERR	
ENDTRY	//End Full Program Error Recovery

}

//End main program




//Function that makes a basic TI 89 command 
//Example:  Define x=1:Define y=x+1
void basic(char *string)
{
	HANDLE handle;
	push_parse_text (string);
	handle = HS_popEStack ();
	NG_execute (handle, 0);
	HeapFree (handle);
}


//End of File
