
/*
     					Folder Info
                            =============
                by Zeljko Juric and Sebastian Reichelt


This is an ASM function for the TI-89 and TI-92 Plus.  It gives BASIC
programmers the ability to request folder information at runtime.  It
is very easy to use:

foldinfo()
returns a list of all folders.

foldinfo("folder")
returns a list of all variables in the folder "folder".
*/

#define RETURN_VALUE 

#include <nostub.h>
#include <args.h>
#include <estack.h>
#include <vat.h>

int _ti89;           // Produce .89Z File


// Main Function
int _main()
{
	ESI argptr = top_estack;
	int FindType;
	SYM_ENTRY *SymPtr;
	
	if (GetArgType(argptr) == END_TAG)
		FindType = 0;
	else
		FindType = 1;
		
	SymPtr = SymFindFirst (GetSymstrArg (argptr), FindType);
	push_END_TAG();
	while (SymPtr)
	{
		push_ANSI_string (SymPtr->name);
		SymPtr = SymFindNext();
	}
	push_LIST_TAG();
	return 0;
}
